
const string NUMBER = "0123456789";

namespace Intercept {
    bool Destroy(CMwStack &in stack, CMwNod@ nod) {
        CNetScriptHttpRequest@ req;
        try {
            @req = cast<CNetScriptHttpRequest@>(stack.CurrentNod());
        } catch {
            trace('invalid http request destroy: ' + getExceptionInfo());
            return true;
        }
        if (req is null) {
            trace("null request destroy");
            return true;
        }
        if (!req.IsCompleted) {
            // trace("incomplete request: url: " + req.Url + ", complete: " + req.IsCompleted + ", code: " + req.StatusCode + ", result: " + req.Result);
            return true;
        }
        if (req.StatusCode != 200) {
            // trace("invalid request: url: " + req.Url + ", complete: " + req.IsCompleted + ", code: " + req.StatusCode + ", result: " + req.Result);
            return true;
        }
        
        if (!req.Url.StartsWith(NadeoServices::BaseURLLive())) {
            return true;
        }
        string url = req.Url.SubStr(NadeoServices::BaseURLLive().Length);
        if (url.StartsWith("/api/token/club/")) {
            url = url.SubStr(16);
            // print(url);
            int i = 0;
            while (NUMBER.Contains(url.SubStr(i, 1)) && i < url.Length) {
                i++;
            }
            string club = url.SubStr(0, i);
            url = url.SubStr(i);
            if (url != "" && url.StartsWith("/room/")) {
                startnew(NadeoActivities::_GetMapsFromNadeoRoom_viewed, ref(req));
            }
        }


        return true;
    }


    bool active = false;
    void Init() {
        if (active) {
            print('intercept already active');
            return;
        }
        try {
            Dev::InterceptProc("CNetScriptHttpManager", "Destroy", Destroy);
        } catch {
            print("Destroy: " + getExceptionInfo());
            Intercept::Reset();
        }
    }
    void Reset() {
        if (active) {
            print('intercept not active');
            return;
        }
        try {
            Dev::ResetInterceptProc("CNetScriptHttpManager", "Destroy");
        } catch {
            active = true;
            print("Destroy: " + getExceptionInfo());
        }
    }
}